# This file contains generic procedures mainly


# return random index [0 to cnt-1]
proc ranindex {cnt} {

   if {$cnt<1} {puts "ranindex: invalid count" exit 1}
   # rnlist = list of random number
   for {set i 0} { $i < $cnt } {incr i} {
       lappend rnlist "$i [expr int(rand()*[expr 5*$cnt])]"         
   }  

   # rlist = list of random index
   set rnlist [lsort -integer -index 1 $rnlist]
   foreach m $rnlist {
	lappend rlist [lindex $m 0]
   } 
   return $rlist
}


# reshuffles a list
proc reshuffle {slist} {

    set cnt [llength $slist]
    if {$cnt<2} {return $slist}

    set rindexes [ranindex $cnt]

    foreach i $rindexes {
       lappend rslist [lindex $slist $i]
    }
    return $rslist
}


# sorts the list according to reqtime
proc reqsort {slist} {

   set tindex 0
   foreach dloader $slist {
	lappend tlist " $tindex [$dloader set reqtime] "
        incr tindex 1
   }

   set tlist [lsort -real -index 1 $tlist]
   foreach m $tlist {
	lappend nlist [lindex $slist [lindex $m 0]]	
   }	

   return $nlist
}


# sorts the list according to reqtime
proc progsort {slist} {

   set tindex 0
   foreach dloader $slist {
	lappend tlist " $tindex [expr 5000 - [$dloader set progress] ] "
        incr tindex 1
   }

   set tlist [lsort -real -index 1 $tlist]
   foreach m $tlist {
	lappend nlist [lindex $slist [lindex $m 0]]	
   }	

   return $nlist
}



# deletes index element from elist
proc edelete {elist index} {
   set cnt [llength $elist]
   set fsublist [lrange $elist 0 [expr $index - 1]]
   set esublist [lrange $elist [expr $index + 1] $cnt]
   set elist [concat $fsublist $esublist]
   return $elist
}



# return random index based on freq count
proc sortindex {cntpieces} {

  if {[llength $cntpieces]<2} {return $cntpieces}

  set ecount [llength $cntpieces]
  for {set i 1} {$i < $ecount} {incr i} {
      set cnt [lindex $cntpieces $i]
      lappend tcnts "$cnt $i"
  }

  # sort the list
  set tcnts [reshuffle $tcnts]
  set tcnts [lsort -integer -index 0 $tcnts]

  foreach m $tcnts {
        lappend rlist [lindex $m 1]
  }
 
  return $rlist
}
